from django.utils import timezone
from django.db import models

# Create your models here.

class Question(models.Model):
    question_text = models.CharField(max_length=500)
    open_time = models.DateTimeField()
    close_time = models.DateTimeField()

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def is_active(self):
        current_time = timezone.now()
        return current_time < self.close_time and current_time > self.open_time
    
    def __str__(self) -> str:
        return f"{self.question_text}"

class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self) -> str:
        return f"[{self.question.pk}]: {self.choice_text}"
