from django.db.models import F
from django.db.models.query import QuerySet
from django.shortcuts import render, get_object_or_404
from django.template import loader
from django.http import HttpResponse, Http404, HttpResponseRedirect
from django.views import generic
from django.urls import reverse

from .models import Choice, Question

# Create your views here.

# def index(request):
#     latest_questions = Question.objects.order_by("-created_at")[:5]

#     template = loader.get_template("index.html")
#     context = {
#         "questions": latest_questions,
#     }

#     return HttpResponse(template.render(context, request))


# def detail(request, question_id):
#     q = get_object_or_404(Question, id=question_id)
#     template = loader.get_template("vote_detail.html")
#     context = {
#         "question": q,
#     }
    
#     return HttpResponse(template.render(context, request))

def results(request, question_id):
    return HttpResponse(f"This is the results page for question {question_id}")

def vote(request, question_id):
    try:
        q = get_object_or_404(Question, id=question_id)
        choice_id = request.POST['choice'][0]
        c = q.choice_set.get(id=choice_id)
        c.votes = F("votes") + 1
        c.save()
    except KeyError:
        return render(
            request,
            "vote_detail.html",
            {
                "question": q,
                "error_message": "Please make a choice!",
            },
        )
    except Exception:
        # Redisplay the question voting form.
        return render(
            request,
            "vote_detail.html",
            {
                "question": q,
                "error_message": "Something bad happened!",
            },
        )

    return HttpResponseRedirect(reverse("polls:detail", args=(q.id,)))


class IndexView(generic.ListView):
    template_name = "index_pretty.html"
    context_object_name = "questions"

    def get_queryset(self):
        return Question.objects.order_by("-created_at")[:5]

class DetailView(generic.DetailView):
    model = Question
    template_name = "vote_detail.html"
